'use strict';

function spectralSlope (args) {
    if (typeof args.ampSpectrum !== "object") {
        throw new TypeError();
    }
    //linear regression
    var ampSum = 0;
    var freqSum = 0;
    var freqs = new Float32Array(args.ampSpectrum.length);
    var powFreqSum = 0;
    var ampFreqSum = 0;
    for (var i = 0; i < args.ampSpectrum.length; i++) {
        ampSum += args.ampSpectrum[i];
        var curFreq = (i * args.sampleRate) / args.bufferSize;
        freqs[i] = curFreq;
        powFreqSum += curFreq * curFreq;
        freqSum += curFreq;
        ampFreqSum += curFreq * args.ampSpectrum[i];
    }
    return ((args.ampSpectrum.length * ampFreqSum - freqSum * ampSum) /
        (ampSum * (powFreqSum - Math.pow(freqSum, 2))));
}

module.exports = spectralSlope;
